
/*
    Developed by Robert Nyman, http://www.robertnyman.com
    Code/licensing: http://code.google.com/p/getelementsbyclassname/
*/

var getElementsByClassName = function (className, tag, elm){
    if (document.getElementsByClassName) {
        getElementsByClassName = function (className, tag, elm) {
            elm = elm || document;
            var elements = elm.getElementsByClassName(className),
                nodeName = (tag)? new RegExp("\\b" + tag + "\\b", "i") : null,
                returnElements = [],
                current;
            for(var i=0, il=elements.length; i<il; i+=1){
                current = elements[i];
                if(!nodeName || nodeName.test(current.nodeName)) {
                    returnElements.push(current);
                }
            }
            return returnElements;
        };
    }
    else if (document.evaluate) {
        getElementsByClassName = function (className, tag, elm) {
            tag = tag || "*";
            elm = elm || document;
            var classes = className.split(" "),
                classesToCheck = "",
                xhtmlNamespace = "http://www.w3.org/1999/xhtml",
                namespaceResolver = (document.documentElement.namespaceURI === xhtmlNamespace)? xhtmlNamespace : null,
                returnElements = [],
                elements,
                node;
            for(var j=0, jl=classes.length; j<jl; j+=1){
                classesToCheck += "[contains(concat(' ', @class, ' '), ' " + classes[j] + " ')]";
            }
            try {
                elements = document.evaluate(".//" + tag + classesToCheck, elm, namespaceResolver, 0, null);
            }
            catch (e) {
                elements = document.evaluate(".//" + tag + classesToCheck, elm, null, 0, null);
            }
            while ((node = elements.iterateNext())) {
                returnElements.push(node);
            }
            return returnElements;
        };
    }
    else {
        getElementsByClassName = function (className, tag, elm) {
            tag = tag || "*";
            elm = elm || document;
            var classes = className.split(" "),
                classesToCheck = [],
                elements = (tag === "*" && elm.all)? elm.all : elm.getElementsByTagName(tag),
                current,
                returnElements = [],
                match;
            for(var k=0, kl=classes.length; k<kl; k+=1){
                classesToCheck.push(new RegExp("(^|\\s)" + classes[k] + "(\\s|$)"));
            }
            for(var l=0, ll=elements.length; l<ll; l+=1){
                current = elements[l];
                match = false;
                for(var m=0, ml=classesToCheck.length; m<ml; m+=1){
                    match = classesToCheck[m].test(current.className);
                    if (!match) {
                        break;
                    }
                }
                if (match) {
                    returnElements.push(current);
                }
            }
            return returnElements;
        };
    }
    return getElementsByClassName(className, tag, elm);
};


    var locale = 'ru';

    function getLabel(label_name){
        return labels[label_name] ? labels[label_name]: '?' + label_name + '?' ;
    }

    function setupLabels(){
        var lablesDivs = getElementsByClassName('mlabel');

        for(var i = 0; i < lablesDivs.length; i++){
            var el = lablesDivs[i];

            if(el.tagName == 'INPUT'){
                var label_name = el.value;
                el.value = getLabel(label_name);

            } else if(el.tagName == 'BUTTON'){
                var label_name = el.innerHTML;
                el.innerHTML = getLabel(label_name);

            } else if(el.tagName == 'IMG'){
                var label_name = el.title;
                el.title = getLabel(label_name);

            } else if(el.tagName == 'SELECT'){
                var s = el;
                for(var j = 0; j < el.options.length; j++){
                    var label_name = el.options[j].text;
                    el.options[j].text = getLabel(label_name);
                }
                
            } else {
                var label_name = el.innerHTML;
                el.innerHTML = getLabel(label_name);

            }
        }
    }

    function setLabel(id, label_name){
        var el = $$$(id);
        if(el.tagName == 'INPUT'){
            el.value = getLabel(label_name);

        } else if(el.tagName == 'BUTTON'){
            el.innerHTML = getLabel(label_name);

        } else if(el.tagName == 'IMG'){
            el.title = getLabel(label_name);

        } else {
            el.innerHTML = getLabel(label_name);

        }    
    }

    //load_clbks.push(setupLabels);
