﻿
    function copyOrCreateTask(data){
        var t = 0;
        if (tasksHash && tasksHash[parseInt(data['nid'])]){
            t = tasksHash[parseInt(data['nid'])];
        } else {
            t = new Task(data);
        }
        t.updateTask(data);
        return t;
    }

    function Task(data){
        this.nid = parseInt(data['nid']);
        this.subTasks = new Array();
        this.subTasksHash = new Array();

        return this;
    }

    function TaskUpdateTask(data){
        this.puid       = parseInt(data['puid']);
        this.uid        = parseInt(data['uid']);

        this.message    = data['message'];
        this.start_time = data['start_time'];
        this.end_time   = data['end_time'];
        this.on_home_screen = parseInt(data['on_home_screen']);

        this.comment    = data['comment'];
        this.performed  = parseInt(data['performed']);
        this.task_type  = parseInt(data['task_type']);
        this.is_deleted = parseInt(data['is_deleted']);

        this.public     = parseInt(data['public']);
        this.observered_nid = parseInt(data['observered_nid']);
        this.observered_uid = parseInt(data['observered_uid']);
        if(data['observers']){
            this.observers  = data['observers'].split(',');
            this.observersHash = new Array();
            for(var i = 0; i < this.observers.length; i++){
                this.observersHash[this.observers[i]] = 1;
            }
        } else {
            this.observers  = new Array();
            this.observersHash = new Array();
        }


        this.is_list    = data['is_list'] == 'none' ? 0: 1;
        this.list_nid   = parseInt(data['list_nid']);
        this.list_idx   = parseInt(data['list_idx']);
        checkTextLength(this);
    }
    
    function checkTextLength(t){
        if(t.comment){
            t.dis_comment = splitTextLength(t.comment);
        }
        if(t.message){
            t.dis_message = splitTextLength(t.message);
        }
    }
    
    function splitTextLength(t){
        var splited;
        var rtext;
        var lines = t.split('\r');
        for(var j = 0; j < lines.length; j++){
            //alert(lines[j]);
            var msgAr = lines[j].split(' ');
            for(var i = 0; i < msgAr.length; i++){
                if(msgAr[i].length > 34){
                    var txt = msgAr[i];
                    splited = '';
                    var myRe = /.{1,34}/g;
                    while ((myArray = myRe.exec(txt)) != null){
                        splited += '<span style="display: ' + inline_style + '; float: left;">' + myArray[0] + '</span>';
                    }
                }
            }
            if(j > 0){
                rtext += '<br>';
                rtext += splited ? splited: lines[j];
            } else {
                rtext = splited ? splited: lines[j];
            }                        
        }
        return rtext;
    }

    
    function TaskAddSubTask(t){
        if(this.subTasksHash[t.nid]){
            this.subTasksHash[t.nid] = t;
        } else {
            this.subTasksHash[t.nid] = t;
        }
        this.subTasks = new Array();
        for(var nid in this.subTasksHash){
            if(this.subTasksHash[nid].is_deleted != 1){
                this.subTasks.push(this.subTasksHash[nid]);
            }
        }
    }
    
    function TaskSortSubTask(){    
        this.subTasks.sort(function(a, b){return a.list_idx - b.list_idx});            
        
    }
    Task.prototype.sortSubTask = TaskSortSubTask;
    Task.prototype.addSubTask = TaskAddSubTask;
    Task.prototype.updateTask = TaskUpdateTask;

//-----------------------------------------------------------

    function setTasksDates(data){
        var tasks_list = data['tasks_list'];
        log('tasks_list = ' + tasks_list.length + '<BR>');
        for(var i = 0; i < tasks_list.length; i++){        	
            var d = tasks_list[i]['dates'].split(' ');
            fillTasksDatesList(d[0] + ' 00:00:00', d[1] + ' 00:00:00');
        }
    }

    function fillTasksDatesList(str1, str2){        
        var d1 = mysqlstr2d(str1);
        var d2 = mysqlstr2d(str2);        

        tasksDatesList[d2str(d1)] = 1;
        d1.setDate(d1.getDate() + 1);        
        for(var i = 1; d1 < d2; i++){            
            tasksDatesList[d2str(d1)] = 1;        
            d1.setDate(d1.getDate() + 1);
        }
        tasksDatesList[d2str(d2)] = 1;        
    }
    

    function setTasks(data){
        var tsks = data['tasks'];
                    
        var taskSubList = new Array();
        for(var i = 0; i < tsks.length; i++){
            var t = copyOrCreateTask(tsks[i]);
            if(t.observered_nid > 0 && t.observered_uid != UID ){
                // ?? ????
            } else if(t.list_nid > 0){
                taskSubList.push(t);
            } else {
                tasksHash[t.nid] = t;
            }
            if(! t.is_deleted){
            	fillTasksDatesList(t.start_time, t.end_time);           
        	}
        }

        if(taskSubList.length > 0){                        
            var sortedTasks = new Array();
            for(var i = 0; i < taskSubList.length; i++){
                if(tasksHash[taskSubList[i].list_nid]){
                    tasksHash[taskSubList[i].list_nid].addSubTask(taskSubList[i]);
                    sortedTasks.push(taskSubList[i].list_nid);
                }
            }
            try{
                for(var i = 0; i < sortedTasks.length; i++){
                    tasksHash[sortedTasks[i]].sortSubTask();
                }
            } catch (e){
                alertError(e);
            }
        }
        
        

        tasks = new Array();
        homeScreenTasks = new Array();
        for(var i in tasksHash){
            tasks.push(i);
            if(tasksHash[i].on_home_screen){
                homeScreenTasks.push(i);
            }
        }
    }
    
    
    function getTasksOnDate(d){
        var rArray = new Array();
        var cur_date = d2mysqlstr(d);
        for(var i = 0; i < tasks.length; i++){
            var t = tasksHash[tasks[i]];
            var start_date  = (t.start_time.split(' ')[0]);
            var end_date    = (t.end_time.split(' ')[0]);
            if(start_date == cur_date || end_date == cur_date){
                rArray.push(t);
            } else if(start_date <= cur_date && end_date >= cur_date){
                rArray.push(t);
            }
        }
        return rArray;
    }    
    



//---------------------------------------------------------------

    function taskFormSetListChanged(){
        if(! $$$('taskFormSetList').checked){
            $$$('taskFormSetList').checked = true;
            taskSetList();

        } else {
            if(confirm(getLabel('areyouremovetasklist'))){
                $$$('taskFormSetList').checked = false;
                taskSetList();
            } else {

            }
        }
    }    
    
    var AdvSubTasksShowMode = 0;
    if(! WIDGET_MODE){
        AdvSubTasksShowMode = 1;
    }
    
    function showHideAdvSubTasks(){
    	var els = getElementsByClassName('sub_task_adv');
    	for(var i = 0; i < els.length; i++){
            els[i].style.display = AdvSubTasksShowMode ? inline_style: 'none';
    	}
        els = getElementsByClassName('sub_task_textarea');
		for(var i = 0; i < els.length; i++){
			if(! AdvSubTasksShowMode){
				els[i].style.display = 'none';
    		}
    	}    	
    	if(AdvSubTasksShowMode){
    		hide('taskFormDeleteLastTaskFromListDiv');
    	} else {
    		show('taskFormDeleteLastTaskFromListDiv');
    	}
	}
	
    function taskSetList(){
        if($$$('taskFormSetList').checked == true){
            show('taskFormListLabel', inline_style);
            show('taskFormAddTaskListLabel', inline_style);
            taskFormSetListCounter = 0;
            $$$('taskFormListDiv').innerHTML = '';
            $$$('taskFormSetListLabelParent').style.textAlign = 'right';
            setLabel('taskFormSetListLabel', 'removetasklist');
            //alertError($$$('taskFormSetListLabel').style);
            $$$('taskFormSetListLabel').onclick = taskFormSetListChanged;
            var html = '';            
            taskAddTaskList(0, '', '');            
			
        } else {
            hide('taskFormListLabel');
            $$$('taskFormListDiv').innerHTML = '';
            hide('taskFormAddTaskListLabel');
            setLabel('taskFormSetListLabel', 'settasklist');
            $$$('taskFormSetListLabelParent').style.textAlign = 'left';
            $$$('taskFormSetListLabel').onclick = taskFormSetListChanged;        	
            hide('taskFormDeleteLastTaskFromListDiv');
        }
    }

    function getTaskFormListDivHTML(idx, id){
        var div = $$$('taskFormListDiv_' + idx);
        if(div){
            var sbjct = $$$('taskFormListTaskSubject_' + idx).value;
            var nid = $$$('taskFormListTaskNid_' + idx).value;
            var comment = $$$('taskFormListTaskComment_' + idx).value;
            var display = $$$('taskFormListTaskComment_' + idx).style.display;

            return addTaskListHTML(nid, '', comment, display, id);
        }
        return '';

    }
    
    function downSubTask(tid){
        moveSubTask(tid, +1);
    }
    
    function upSubTask(tid){
        moveSubTask(tid, -1);
    }    
    
    function moveSubTask(tid, step){
    
        if(step < 0 && tid == 0){return;}   
        if(step > 0 && tid == taskFormSetListCounter - 1){return;}
        
        var from_idx = tid;
        var to_idx = tid + step;
        
        var from_sbjct      = getValue('taskFormListTaskSubject_' + from_idx);
        var from_nid        = getValue('taskFormListTaskNid_' + from_idx);
        var from_comment    = getValue('taskFormListTaskComment_' + from_idx);
        var from_display    = $$$('taskFormListTaskComment_' + from_idx).style.display;

        var to_sbjct    = getValue('taskFormListTaskSubject_' + to_idx);
        var to_nid      = getValue('taskFormListTaskNid_' + to_idx);
        var to_comment  = getValue('taskFormListTaskComment_' + to_idx);
        var to_display  = $$$('taskFormListTaskComment_' + to_idx).style.display;


        setValue('taskFormListTaskSubject_' + from_idx, to_sbjct);
        setValue('taskFormListTaskNid_' + from_idx, to_nid);
        setValue('taskFormListTaskComment_' + from_idx, to_comment);
        $$$('taskFormListTaskComment_' + from_idx).style.display = to_display;

        setValue('taskFormListTaskSubject_' + to_idx, from_sbjct);
        setValue('taskFormListTaskNid_' + to_idx, from_nid);
        setValue('taskFormListTaskComment_' + to_idx, from_comment);
        $$$('taskFormListTaskComment_' + to_idx).style.display = from_display;



    }

    
    
    function deleteTaskFromTaskList(tid){
        if(! confirm(getLabel('aredeletesubtask'))){
            return; 
        }
        
        var id = 0;
        var html = '';
        var sbjcts = new Array();
        for(var i = 0; i < taskFormSetListCounter; i++){
            if( i != tid){
                html += getTaskFormListDivHTML(i, id);
                sbjcts[id] = getValue('taskFormListTaskSubject_' + i);
                id++;
            }
        }
        $$$('taskFormListDiv').innerHTML = html;
        taskFormSetListCounter = id;
        
        hide('upSubTaskImg_' + 0);
        if(taskFormSetListCounter > 0){
            var last_id = taskFormSetListCounter - 1;
            hide('downSubTaskImg_' + last_id);
        }        
        for(var i = 0; i < taskFormSetListCounter; i++){
            $$$('taskFormListTaskSubject_' + i).onkeypress = subTaskInputKeyPress;
            setValue('taskFormListTaskSubject_' + i, sbjcts[i]);
        }
        
        showHideAdvSubTasks();
    }

	function subTaskInputKeyPress(e){ 
		var e;
		if (!e){e = window.event};
		if(e.keyCode == 13){
            addNewTaskToSubList();
		}
	}
    
    function addNewTaskToSubList(){
        taskAddTaskList(0, '', '', 1);
        
        hide('upSubTaskImg_' + 0);
        if(taskFormSetListCounter > 0){
            var last_id = taskFormSetListCounter - 1;
            hide('downSubTaskImg_' + last_id);
        }
    }

    function taskAddTaskList(nid, sbjct, comment, focus_flag){
        var html = '';
        var id = 0;
        var sbjcts = new Array();
        for(var i = 0; i < taskFormSetListCounter; i++){
            html += getTaskFormListDivHTML(i, id);
            sbjcts[i] = getValue('taskFormListTaskSubject_' + i);
            id++;
        }
        html += addTaskListHTML(nid, sbjct, comment, 'none', id);
        $$$('taskFormListDiv').innerHTML = html;
        sbjcts[id] = '';
        
        id++;
        taskFormSetListCounter = id;
        
		for(var i = 0; i < id; i++){
			$$$('taskFormListTaskSubject_' + i).onkeypress = subTaskInputKeyPress;
            setValue('taskFormListTaskSubject_' + i, sbjcts[i]);
        }
        
        if(focus_flag){
            $$$('taskFormListTaskSubject_' + (id - 1)).focus();                        
        }
        showHideAdvSubTasks();
    }


    function showTaskFormComment(hide){
        if(hide || $$$('taskFormComment').style.display != 'none'){            
            $$$('taskEditComment').style.display = 'none';
        } else {            
            $$$('taskEditComment').style.display = '';
        }
    }

    function showTaskComment(id){
        if($$$('taskFormListTaskComment_' + id).style.display == 'none'){
            $$$('showTaskCommentImg_' + id).title = getLabel('hidetasknote');
            $$$('taskFormListTaskComment_' + id).style.display = '';
        } else {
            $$$('showTaskCommentImg_' + id).title = getLabel('addtasknote');
            $$$('taskFormListTaskComment_' + id).style.display = 'none';
        }
    }

    function addTaskListHTML(nid, sbjct, comment, display, id){
        var html = '';
        html += '<div id="taskFormListDiv_' + id + '">';
        
        html += '<input type="text" id="taskFormListTaskSubject_' + id + '" value="' + sbjct + '" style="width: 100%;">';
        html += '<input type="hidden" id="taskFormListTaskNid_' + id + '" value="' + nid + '">';        
             
        html += '<div class="sub_task_adv" style="display: ' + inline_style + '; text-align: left; width: 60%; margin: 5px 0px 15px 0px; ">';          
        html += '<a href="#" id="showTaskCommentImg_' + id + '" onclick="showTaskComment(' + id + '); return false;">' + getLabel('description') + '</a>';
        html += '&nbsp;&nbsp;&nbsp;';
        html += '<a href="#" id="downSubTaskImg_' + id + '" onclick="downSubTask(' + id + '); return false;">' + getLabel('down') + '</a>';
        html += '&nbsp;&nbsp;&nbsp;';
        html += '<a href="#" id="upSubTaskImg_' + id + '" onclick="upSubTask(' + id + '); return false;">' + getLabel('up') + '</a>';
        html += '</div>';  
        html += '<div class="sub_task_adv" style="display: ' + inline_style + '; text-align: right; width: 35%; margin: 5px 0px 15px 0px; ">';  
        html += '<a href="#" onclick="deleteTaskFromTaskList(' + id + '); return false;">' + getLabel('delete') + '</a>';
        html += '</div>';  
        html += '<textarea class="sub_task_textarea"  style="display:' + display + '; margin: 0px 0px 20px 0px" id="taskFormListTaskComment_'  + id + '">' + comment + '</textarea>';
        html += '</div>';
        return html;

    }
    
    function editTask(nid){
        var t = tasksHash[nid];
        AdvSubTasksShowMode = 0;
        if(! WIDGET_MODE){
            AdvSubTasksShowMode = 1;
        }
        
        //setValue('taskEditUID', t.uid);
        setValue('taskEditFormUserSelect', t.uid);
        
        setValue('taskEditNID', nid);
        setValue('taskEditMessage', t.message);
        setValue('taskEditComment', t.comment);
        if(t.comment != ''){
            show('taskEditComment');
        } else {
            hide('taskEditComment');
        }
                
        //setValue('taskEditStartDate', sh_dt2str(mysqlstr2d(t.start_time)));
        //setValue('taskEditEndDate', sh_dt2str(mysqlstr2d(t.end_time)));
                
        setValue('taskEditStartDateInput', mysqlstr2humanstr(t.start_time));
        setValue('taskEditEndDateInput', mysqlstr2humanstr(t.end_time));
        
        setValue('taskEditStartDate', sh_dt2str(mysqlstr2d(t.start_time)));
        setValue('taskEditEndDate', sh_dt2str(mysqlstr2d(t.end_time)));
                
        //  $$$('taskFormAddObservers').checked = t.public > 0 ? true: false;
        //  checkAddObservers(t.observersHash);

        $$$('taskEditFormOnHomeScreen').checked = t.on_home_screen == 1 ? true: false;
        $$$('taskFormSetList').checked = t.subTasks.length > 0 ? true: false;
        if($$$('taskFormSetList').checked == true){
            taskSetList();
            $$$('taskFormListDiv').innerHTML = '';
            taskFormSetListCounter = 0;
        } else {
            taskSetList();
        }
        var html = '';
        for(var i = 0; i < t.subTasks.length; i++){
            var subt = t.subTasks[i];
            //taskAddTaskList(subt.nid, subt.message, subt.comment);
            html += addTaskListHTML(subt.nid, subt.message, subt.comment, 'none', i);
        }
        $$$('taskFormListDiv').innerHTML = html;
        
        for(var i = 0; i < t.subTasks.length; i++){
            var subt = t.subTasks[i];
            setValue('taskFormListTaskSubject_' + i, subt.message);
            $$$('taskFormListTaskSubject_' + i).onkeypress = subTaskInputKeyPress;
        }        
        taskFormSetListCounter = t.subTasks.length;
        
        if(t.subTasks.length > 0){
            var last_id = t.subTasks.length - 1;
            
            hide('upSubTaskImg_' + 0);
            hide('downSubTaskImg_' + last_id);
        }

        showHideAdvSubTasks();
        //$$$("taskFormSubject").onkeypress = taskFormSubjectKeyPress;
        hideAll();                
        if(WIDGET_MODE){
            hide('buttonsForm');
        } else {
            window.setTimeout("show('usersForm'); show('calendarForm');", 200);    
        }
        window.setTimeout("show('taskEditForm')", 200);
    }

    function taskEditEndDateChange()
    {
        var newValue = sh_dt2str(mysqlstr2d(getValue('taskEditEndDateInput')));
        setValue('taskEditEndDate', newValue);
    }
    
    function taskEditStartDateChange(){
        var newValue = sh_dt2str(mysqlstr2d(getValue('taskEditStartDateInput')));
        setValue('taskEditStartDate', newValue);
    }

    function saveTask(){
        var sd      = getValue('taskEditStartDateInput');
        var ed      = getValue('taskEditEndDateInput');
        
        //var pid     = getValue('taskEditUID');
        var pid     = getValue('taskEditFormUserSelect');
        
        var tid     = getValue('taskEditNID');
        var sbjt    = getValue('taskEditMessage');
        var comment = getValue('taskEditComment');
        var on_home_screen = $$$('taskEditFormOnHomeScreen').checked == true? 1: 0;
        
        var taskList = new Array();
        if($$$('taskFormSetList').checked){
            for(var i = 0; i < taskFormSetListCounter; i++){
                var div = $$$('taskFormListDiv_' + i);
                if(div){
                    var obj     = new Object();
                    obj.sbjct   = $$$('taskFormListTaskSubject_' + i).value;
                    obj.nid     = $$$('taskFormListTaskNid_' + i).value;
                    obj.comment = $$$('taskFormListTaskComment_' + i).value;
                    taskList.push(obj);
                }
            }
        }

        var observers = new Array();
        //  if($$$('taskFormAddObservers').checked){
        //      for(var i in users){
        //          var u = users[i];
        //          var id = 'observersCB_' + u.puid;
        //          if($$$(id) && $$$(id).checked){
        //              observers.push(u.puid);
        //          }
        //      }
        //  }
        
        sendTask(pid, sbjt, comment, sd, ed, tid, observers.join(','), taskList, on_home_screen);
    }

function createTask(sel_uid){
    showNewTaskForm(sel_uid);
}    


function showNewTaskForm(sel_uid){
    AdvSubTasksShowMode = 0;
    if(! WIDGET_MODE){
        AdvSubTasksShowMode = 1;
    }
    
    //setValue('taskEditUID', sel_uid);
    setValue('taskEditFormUserSelect', sel_uid);
    setValue('taskEditNID', 0);
    setValue('taskEditMessage', '');
    setValue('taskEditComment', '');
    $$$('taskFormSetList').checked = false;

    var start_date_str = d2str(selectedDate) + ' 00:00:00';                
    var end_date_str = d2str(selectedDate) + ' 23:59:00';                
    setValue('taskEditStartDateInput', start_date_str);
    setValue('taskEditEndDateInput', end_date_str);

    setValue('taskEditStartDate', sh_dt2str(mysqlstr2d(start_date_str)));
    setValue('taskEditEndDate', sh_dt2str(mysqlstr2d(end_date_str)));

    hide('taskEditComment');

    //$$$("taskFormUserLabel").innerHTML = users[sel_uid].name;
    //$$$("taskFormSubject").onkeypress = taskFormSubjectKeyPress;
    //$$$('taskFormAddObservers').checked = false;
    //checkAddObservers();
    //$$$('taskFormSetList').checked = false;
    
    try{
        taskSetList();
        //$$$("taskFormSubject").focus();
    } catch(e){}

    setView(EDIT_TASK);    
}
